<?php
/*
Plugin Name: Tevolution Coupon Manager
Plugin URI: //templatic.com/docs/tevolution-guide/
Description: This Directory add-on lets you create discount coupons which listing authors can use while paying for a listing submission.
Version: 1.0.5
Author: Templatic
Author URI: //templatic.com/
*/


define( 'MANAGE_COUPON_FOLDER_NAME','Tevolution-Coupon-Manager' );
define( 'MANAGE_COUPON_VERSION','1.0.5' );
define( 'MANAGE_COUPON_PLUGIN_NAME','Tevolution Coupon Manager' );
define( 'MANAGE_COUPON_SLUG','Tevolution-Coupon-Manager/manage-coupon.php' );

// Plugin Folder URL
define( 'MANAGE_COUPON_URL', plugin_dir_url( __FILE__ ) );
// Plugin Folder Path
define( 'MANAGE_COUPON_DIR', plugin_dir_path( __FILE__ ) );

$locale = get_locale();

load_textdomain( 'coupon-templatic', plugin_dir_path( __FILE__ ) . 'languages/' . $locale . '.mo' );

define( 'DISCOUNT_TYPE_TITLE',__( 'Discount Type','coupon-templatic' ) );
define( 'COUPON_CODE_TITLE',__( 'Coupon&nbsp;Code','coupon-templatic' ) );
define( 'DISCOUNT_AMOUNT_TITLE',__( 'Discount Amount','coupon-templatic' ) );
define( 'COUPON_ST_DATE_DESC',__( 'Select date from which coupon will be active. After end date coupon will no longer work','coupon-templatic' ) );
define( 'COUPON_TYPE_DESC',__( 'Choose how the discount should be calculated','coupon-templatic' ) );
define( 'COUPON_AMOUNT_DESC',__( 'Specify the discount amount.Values will be discounted based on the amount and the discount type selected in abve fields<br><strong>Note:</strong>Enter only numeric values for both amount type and percent type','coupon-templatic' ) );



add_action( 'admin_init','tmpl_manage_coupon_files_include' );
add_action( 'wp_ajax_check_coupon_code_exist','tmpl_check_coupon_code_exist' );

add_action( 'wp_ajax_submit_form_coupon_code','tmpl_submit_form_coupon_code' );
add_action( 'wp_ajax_nopriv_submit_form_coupon_code','tmpl_submit_form_coupon_code' );


/*include admin coupon install filer */
function tmpl_manage_coupon_files_include() {
	include_once( MANAGE_COUPON_DIR . 'admin/coupon_install.php' );

	/* renew product code starts here */
	if ( is_admin() ) {
		$tmpl_renew_product = get_option( 'tmpl_renew_product' );

		$tmpl_renew_product_array = explode( ',',$tmpl_renew_product );
		foreach ( $tmpl_renew_product_array as $key => $val ) {
			$tmpl_renew_product_array = explode( '=',$val );
			$tmpl_item_id[] = $tmpl_renew_product_array[1];
			$tmpl_slug[ $tmpl_renew_product_array[1] ] = $tmpl_renew_product_array[0];
			$tmpl_invoice_id[ $tmpl_renew_product_array[1] ] = $tmpl_renew_product_array[2];
			$tmpl_invoice_item_id[ $tmpl_renew_product_array[1] ] = $tmpl_renew_product_array[3];
		}
		if ( (is_network_admin() || ! is_multisite() ) && in_array( MANAGE_COUPON_SLUG,$tmpl_slug ) ) {
			$key = array_search( MANAGE_COUPON_SLUG, $tmpl_slug );
			add_action( 'after_plugin_row_' . MANAGE_COUPON_SLUG, 'tmpl_notify_manage_coupons_renew_product',11 );
		}
		if ( ! function_exists( 'tmpl_notify_manage_coupons_renew_product' ) ) {
			function tmpl_notify_manage_coupons_renew_product( $plugin_file, $plugin_data, $status ) {
				$current = get_site_transient( 'update_plugins' );
				$tmpl_renew_product = get_option( 'tmpl_renew_product' );
				$tmpl_renew_product_array = explode( ',',$tmpl_renew_product );

				foreach ( $tmpl_renew_product_array as $key => $val ) {
					$tmpl_renew_product_array = explode( '=',$val );
					$tmpl_item_id[] = $tmpl_renew_product_array[1];
					$tmpl_slug[ $tmpl_renew_product_array[1] ] = $tmpl_renew_product_array[0];
					$tmpl_invoice_id[ $tmpl_renew_product_array[1] ] = $tmpl_renew_product_array[2];
					$tmpl_invoice_item_id[ $tmpl_renew_product_array[1] ] = $tmpl_renew_product_array[3];
				}
				if ( (is_network_admin() || ! is_multisite() ) && in_array( MANAGE_COUPON_SLUG,$tmpl_slug ) ) {
					$key = array_search( MANAGE_COUPON_SLUG, $tmpl_slug );
					echo '<tr class="plugin-update-tr tev-plugin-renew"><td colspan="3" class="plugin-update"><div class="update-message"> ' . __( 'Your Membership has been expired. You can Renew it from ','templatic-admin' ) . '<span style="color: #0073aa; cursor: pointer;" id="tmpl_redirect" target="_blank" data-key="' . $key . '" data-invoice-id="' . $tmpl_invoice_id[ $key ] . '" data-invoice-item-id="' . $tmpl_invoice_item_id[ $key ] . '" class="thickbox" title="Templatic renew">' . __( 'Here','templatic-admin' ) . '</span></div></td></tr>';

				}
				 add_action( 'admin_footer','tmpl_redirect_temp' );
			}
		}
	}// End if().
	/* renew product code ends here */

}


/* check coupon code exists with same start and end date  */
function tmpl_check_coupon_code_exist() {
	global $wpdb;
	$post_table = $wpdb->prefix . 'posts';
	$add_coupon = sanitize_text_field( $_REQUEST['add_coupon'] );
	$coupon_code = sanitize_text_field( $_REQUEST['add_coupon'] );
	$startdate	= $_REQUEST['startdate'];
	$enddate 	= $_REQUEST['enddate'];
	$post_id	= intval( $_REQUEST['post_id'] );
	$subsql = '';
	if ( isset( $post_id ) && $post_id != '' ) {
		$subsql = " and ID != $post_id";
	}
	$add_coupon_query = "select ID from $post_table where post_title =%s and post_type ='coupon_code' and post_status='publish' $subsql ";
	$coupon_id = $wpdb->get_var( $wpdb->prepare( $add_coupon_query,$add_coupon ) );
	$coupon_startdate = get_post_meta( $coupon_id,'startdate',true );
	$coupon_enddate = get_post_meta( $coupon_id,'enddate',true );
	$result = '0';

	$couponcode1 = "select post_title from $post_table where post_title =%s and post_type ='coupon_code' and post_status='publish'";
	$couponcodeexists = $wpdb->get_var( $wpdb->prepare( $couponcode1,$coupon_code ) );

	/*Check start date and end date is blank then displau message */
	if ( $startdate == '' && $enddate == '' ) {
		$result = '<p>' . __( 'Please select coupon start date and end date.','coupon-templatic' ) . '</p>';
		echo trim( $result );
		exit;
	}
	/*Check same coupon code in same start date and end date between */
	if ( ($coupon_startdate <= $startdate &&  $coupon_enddate >= $startdate) || ($coupon_startdate <= $enddate &&  $coupon_enddate >= $enddate) ) {
		$result = __( '<p>Coupon already exist with the same name and within the same start date and end date period.</p>','coupon-templatic' );
	} elseif ( $couponcodeexists == $coupon_code ) {
		/*check same coupon code exists */
		$result = __( '<p>Coupon already exist with the same name.</p>','coupon-templatic' );
	}
	echo trim( $result );
	exit;
}


/*
Name :templ_get_coupon_fields
Args :coupon_code
description : fetching coupon code field in submit form
*/
function templ_get_coupon_fields( $coupon_code = '' ) {
	?>
	<div id="submit_coupon_code" style="display:none;" class="form_row clearfix">            
		<label><?php  _e( 'Coupon Code','coupon-templatic' );?> </label>
		<input type="text" name="add_coupon" id="add_coupon" class="textfield" value="<?php echo esc_attr( stripslashes( $coupon_code ) ); ?>" />
		&nbsp;
		<input class="validate_btn" type="button" name="validate_coupon_code" id="validate_coupon_code" value="<?php _e( 'Validate','coupon-templatic' );?>" onclick="return checkCoupon();"  />
		<div id="msg_coudon_code"></div>
		<span class="message_note"><?php _e( 'Enter coupon code here (optional)','coupon-templatic' ); ?></span>				
	</div>
<?php
}

/* get the final post submit payable amount after check valid coupon code price reduce from total payable amounts */
function tmpl_payable_amount_after_add_coupon( $payable_amount, $add_coupon ) {
	global $wpdb;
	if ( $add_coupon != '' ) {
		$post_table = $wpdb->prefix . 'posts';
		$add_coupon	= "select ID from $post_table where post_title ='" . $add_coupon . "' and post_type ='coupon_code' and post_status='publish'";
		$coupon_id	= $wpdb->get_var( $add_coupon );
		$coupondisc = get_post_meta( $coupon_id,'coupondisc',true );
		$couponamt 	= get_post_meta( $coupon_id,'couponamt',true );
		$start_date = strtotime( get_post_meta( $coupon_id,'startdate',true ) );
		$end_date 	= strtotime( get_post_meta( $coupon_id,'enddate',true ) );
		$todays_date = strtotime( date( 'Y-m-d' ) );
		$total_price = $payable_amount;
		/* Check coupon code active on current date on coupon date raneg */
		if ( $start_date <= $todays_date && $end_date >= $todays_date ) {
			/* Checl total price greater than zero */
			if ( $total_price > 0 ) {
				/* reeuce payable amount percentag wise */
				if ( $coupondisc == 'per' ) {
					$price = (($total_price * $couponamt) / 100);
					$payable_amount = $total_price - $price;
				}
				/*Reduce payable amount fix amount wise */
				if ( $coupondisc == 'amt' && $total_price > $couponamt ) {
					$payable_amount = $total_price - $couponamt;
				}
			}
		}
	}

	/*tmpl_payable_amount_after_add_coupon filter hook for reduce extra payable amount  */
	return apply_filters( 'tmpl_payable_amount_after_add_coupon',$payable_amount,$add_coupon,$total_price );
}


/* Check submit form coupon code validation  */
function tmpl_submit_form_coupon_code() {
	global $wpdb;
	$post_table = $wpdb->prefix . 'posts';
	$add_coupon = $_REQUEST['add_coupon'];
	$add_coupon	= "select ID from $post_table where post_title ='" . $add_coupon . "' and post_type ='coupon_code' and post_status='publish'";
	$coupon_id	= $wpdb->get_var( $add_coupon );
	$coupondisc = get_post_meta( $coupon_id,'coupondisc',true );
	$couponamt 	= get_post_meta( $coupon_id,'couponamt',true );
	$start_date = strtotime( get_post_meta( $coupon_id,'startdate',true ) );
	$end_date 	= strtotime( get_post_meta( $coupon_id,'enddate',true ) );
	$todays_date = strtotime( date( 'Y-m-d' ) );
	   // $result =array();
	/*remove comma from price*/

	//$price = explode( get_option( 'tmpl_price_decimal_sep' ) ,$_REQUEST['total_price'] );
	//$_REQUEST['total_price'] = $price[0];
	$total_price = str_replace( ',', '',$_REQUEST['total_price'] );
	/* check start date and end date with current date */
	if ( $start_date <= $todays_date && $end_date >= $todays_date ) {
		/*Coupon code discount as per percentag wise */
		if ( $coupondisc == 'per' ) {
			if ( $total_price > 0 ) {
				$price = (($total_price * $couponamt) / 100);
				$price = $total_price - $price;
				if ( $price > 0 ) {
					$showPrice = display_amount_with_currency_plugin( $price );
				} 

				if ( $price >= 0 || $couponamt == 100 ) {
					if ( $price <= 0 ) {
						$result['msg'] = sprintf( __( 'Coupon added successfully.','coupon-templatic' ) );
					} else {
						$result['msg'] = sprintf( __( 'Your coupon code has been applied. The new price is %s','coupon-templatic' ),$showPrice );
					}
				}
			}
		}
		/*Coupon code discount as per amount wise */
		if ( $coupondisc == 'amt' ) {
			if ( $total_price > 0 ) {
				$price = $total_price - $couponamt;
				if ( $price > 0 ) {
					$result['msg'] = sprintf( __( 'Your coupon code has been applied. The new price is %s','coupon-templatic' ),display_amount_with_currency_plugin( $price ) );
				}
			}
		}
		$result['price'] = $price;
	} else {
		$result['msg'] = __( 'Your coupon code has been Expired.','coupon-templatic' );
	}// End if().
	echo json_encode( $result );
	exit;
}



/*
Name :templa_script_validatecoupon
description : validate coupon code field on submit form
*/
add_action( 'wp_head','templa_script_validatecoupon',12 );
function templa_script_validatecoupon() {
	global $wp_query,$post;
	// If a static page is set as the front page, $pagename will not be set. Retrieve it from the queried object
	if ( isset( $post ) ) {
		$is_tevolution_submit_form = get_post_meta( $post->ID, 'is_tevolution_submit_form', true );
	}
	if ( isset( $post ) ) {
		$is_tevolution_upgrade_form = get_post_meta( $post->ID,'is_tevolution_upgrade_form',true );
	}
	if ( is_page() && ($is_tevolution_submit_form == 1 || $is_tevolution_upgrade_form == 1) ) {
?>
	<!-- Validate coupon code -->
	<script type="text/javascript">
	function checkCoupon()
	{
		if(document.getElementById("add_coupon"))
			add_coupon = document.getElementById("add_coupon").value;
		if(document.getElementById("total_price"))
			final_price = document.getElementById("total_price").value;
	
		jQuery.ajax({
					type: 'POST',
					url: ajaxUrl,					
					data:"action=submit_form_coupon_code&add_coupon="+add_coupon+"&total_price="+final_price,
					success: function(data){
						var result= JSON.parse(data);
						if(result['price'] >= 0){
							jQuery("#msg_coudon_code").html(result['msg']);
							jQuery("#pkg_price").html(result['price']);
							jQuery("#msg_coudon_code").removeClass('message_error2');
							jQuery("#msg_coudon_code").css('color','green');
							jQuery("#msg_coudon_code").css('clear','both');
							console.log( result['price'] );
							if ( result['price'] == 0 ) {
								jQuery('#submit_form_button').attr( 'value', 'Continue' );
							} else {
								jQuery('#submit_form_button').attr( 'value', 'Pay Now' );
							}
						}else{
							jQuery("#msg_coudon_code").html("<?php _e( 'Sorry, the coupon code your entered does not exist.','coupon-templatic' ); ?>");
							jQuery("#msg_coudon_code").css('color','');
							jQuery("#msg_coudon_code").css('clear','');
							jQuery("#msg_coudon_code").addClass('message_error2');
						}
					}			
				});
		
	}
	</script>
<?php }

}

/*Manage ip plugin setting link will be display in plgin section  */
add_filter( 'plugin_action_links_' . plugin_basename( __FILE__ ),'tmpl_manage_coupon_action_links' );
function tmpl_manage_coupon_action_links( $links ) {
	if ( ! is_plugin_active( 'Tevolution/templatic.php' ) ) {
		return $links;
	}

	$plugin_links = array(
		'<a href="' . admin_url( 'admin.php?page=monetization&tab=manage_coupon' ) . '">' . __( 'Settings', 'coupon-templatic' ) . '</a>',
	);
	return array_merge( $plugin_links, $links );
}

add_action( 'admin_init','tmpl_manage_coupon_auto_update' );
function tmpl_manage_coupon_auto_update() {
	global $pagenow;
	remove_action( 'after_plugin_row_Tevolution-Manage-Coupon/manage-coupon.php', 'wp_plugin_update_row' ,10, 2 );
	/* for auto updates */
	if ( $pagenow == 'plugins.php' ) {
		$is_update_page = 0;
		$dateTimestamp1 = get_option( 'tmpl_tcm_update_check_date' );
		if ( trim( $dateTimestamp1 != '' ) ) {
			$dateTimestamp1 = strtotime( $dateTimestamp1 );
		} else {
			update_option( 'tmpl_tcm_update_check_date',date( 'Y-m-d H:i:s' ) );
		}
		$dateTimestamp1 = strtotime( get_option( 'tmpl_tcm_update_check_date' ) );
		$dateTimestamp2 = strtotime( date( 'Y-m-d H:i:s' ) );
		$interval = abs( $dateTimestamp2 - $dateTimestamp1 );
		$hour_diff = intval( round( $interval / 60 ) / 60 );
		if ( $hour_diff > 3 || $is_update_page == 1 ) {
			require_once( 'wp-updates-plugin.php' );
			new WPUpdatesManageCouponUpdater( '//templatic.com/_data/updates/api/index.php', plugin_basename( __FILE__ ) );
			if ( $is_update_page == 0 ) {
				update_option( 'tmpl_tcm_update_check_date',date( 'Y-m-d H:i:s' ) );
			}
		} else {
			require_once( 'wp-updates-plugin.php' );
			new WPUpdatesManageCouponUpdater( '', plugin_basename( __FILE__ ) );
		}
	}
}

/*
 * Function Name: tevolution_update_login
 * Return: update tevolution plugin version after templatic member login
 */
add_action( 'wp_ajax_tevolution_manage_coupon','tevolution_manage_coupon_update_login' );
function tevolution_manage_coupon_update_login() {
	check_ajax_referer( 'tevolution_manage_coupon', '_ajax_nonce' );
	$plugin_dir = rtrim( plugin_dir_path( __FILE__ ), '/' );
	require_once( $plugin_dir . '/templatic_login.php' );
	exit;
}


/*Display used coupon code on success page */
add_action( 'tmpl_after_success_price_package','tmpl_after_success_price_package_coupons' );
function tmpl_after_success_price_package_coupons( $post_id ) {
	global $wpdb;
	if ( isset( $_REQUEST['pid'] ) && $_REQUEST['pid'] != '' && get_post_meta( $_REQUEST['pid'],'add_coupon',true ) != '' ) {
		$add_coupon = get_post_meta( $_REQUEST['pid'],'add_coupon',true );
		$post_table = $wpdb->prefix . 'posts';
		/* Get coupon code id from used coupon code title*/
		$get_coupon_id	= $wpdb->get_var( "select ID from $post_table where post_title ='" . $add_coupon . "' and post_type ='coupon_code' and post_status='publish'" );
		$coupondisc = get_post_meta( $get_coupon_id,'coupondisc',true );
		$couponamt 	= get_post_meta( $get_coupon_id,'couponamt',true );
		/* check used coupon code is amount wise or  Percentage wise*/
		if ( $coupondisc == 'amt' ) {
			$discount = fetch_currency_with_position( $couponamt );
		} else {
			$discount = $couponamt . '%';
		}
		?>
		<p class="margin_right"><?php echo '<label>';
		_e( 'Coupon Code: ','coupon-templatic' );
		echo '</label>';
		echo '<span>';
		echo $add_coupon . '(' . $discount . ')';
		echo '</span>'; ?></p>
		<?php
	}
}
